//+------------------------------------------------------------------+
//|                                          PerceptronIndicator.mq4 |
//|                                                           NoName |
//|                            http://www.tradersforum.net.ru/forum/ |
//+------------------------------------------------------------------+
#property copyright "NoName"
#property link      "http://www.tradersforum.net.ru/forum/"

#property indicator_separate_window
//#property indicator_minimum -1000
//#property indicator_maximum 1000
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Red
//---- input parameters
extern int       x1=69;
extern int       x2=218;
extern int       x3=5;
extern int       x4=155;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2);
   //------------------------------
   IndicatorShortName("Perceptron(x1="+x1+", x2="+x2+", x3="+x3+", x4="+x4+")");
   SetIndexLabel(0,"PercepronUP");
   SetIndexLabel(1,"PercepronDN");
   SetIndexLabel(2,"PercepronLN");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
 double w1 = x1 - 100;
 double w2 = x2 - 100;
 double w3 = x3 - 100;
 double w4 = x4 - 100;
 
   int    counted_bars=IndicatorCounted();
   int    limit=Bars-counted_bars;
   
   for(int i=0; i<limit; i++) {
   
   double a1 = iAC(NULL, 0, i);
   double a2 = iAC(NULL, 0, i+7); 
   double a3 = iAC(NULL, 0, i+14); 
   double a4 = iAC(NULL, 0, i+21);
     
   double res   = w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4;
   
//----
if  (res>0) ExtMapBuffer1[i]=res;
if  (res<0) ExtMapBuffer2[i]=res; 
} 
//----
   return(0);
  }
//+------------------------------------------------------------------+

